# Uppy Transliterate File Name
## Purpose
This module will automatically remove special characters from files that are uploaded through the [Uppy File Uploader](https://drupal.org/project/uppy).

### File Name Alteration Rules
The following rules are used to alter the file names:
* Replace whitespace with '-': `name.replaceAll(' ', '-')`
* Remove remaining unsafe characters: `name.replaceAll(/[^0-9A-Za-z_.-]/g, '');`
* Remove multiple consecutive non-alphabetical characters (underscore,hyphen,and period): `name.replaceAll(/(_)_+|(\.)\.+|(-)-+/g, '$1$2$3');`
* Force lowercase to prevent issues on case-insensitive file systems: `name.toLowerCase();`

## Installation
Currently this module relies on a patch for drupal/uppy which fixes a bug where overrides in drupalSettings.uppyOverrides gets overwritten. [The Drupal.org issue can be found here.](https://drupal.org/i/3487091). This patch also requires the [Add overrides to allow for more customization](https://www.drupal.org/project/uppy/issues/3280585) patch which has been merged in but is not in a release. As such I have added to composer.json the requirement for drupal/uppy ^3.0.1 so the next release (either 3.0.1 or 3.1.0) should contain it.

Otherwise Intall like you would any other Drupal module.
