(function($, drupalSettings) {

  Drupal.uppy_transliterate_filename = Drupal.uppy_transliterate_filename || {}

  Drupal.uppy_transliterate_filename.transliterate = function(currentFile, files) {

    let name = currentFile.name;
    // Replace whitespace.
    name = name.replaceAll(' ', '-');

    // Remove remaining unsafe characters.
    name = name.replaceAll(/[^0-9A-Za-z_.-]/g, '');

    // Remove multiple consecutive non-alphabetical characters (underscore,hyphen,and period)
    name = name.replaceAll(/(_)_+|(\.)\.+|(-)-+/g, '$1$2$3');

    // Force lowercase to prevent issues on case-insensitive file systems.
    name = name.toLowerCase();

    // replace name in the currentFile object
    currentFile.name = name;
    currentFile.data.name = name;
  }

  $(document).ready(function () {
    if (typeof drupalSettings.uppy !== 'undefined') {
      drupalSettings.uppyOverides = drupalSettings.uppyOverides || {};
      for (var id in drupalSettings.uppy) {
        drupalSettings.uppyOverrides[id] = drupalSettings.uppyOverrides[id] || {};
        drupalSettings.uppyOverrides[id].overrides = drupalSettings.uppyOverrides[id].overrides || {};
        drupalSettings.uppyOverrides[id].overrides.onBeforeFileAddedCallbacks = drupalSettings.uppyOverrides[id].overrides.onBeforeFileAddedCallbacks || {};
        drupalSettings.uppyOverrides[id].overrides.onBeforeFileAddedCallbacks.transliterate = function(currentFile, files) {
          Drupal.uppy_transliterate_filename.transliterate(currentFile, files);
        };
      }
    }
  });

})(jQuery, drupalSettings);
